package fxHarakka;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fxHarakka.luokat.Harakka;
import fxHarakka.luokat.Projekti;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.Pane;


public class HarakkaController {


    @FXML
    private Button p1t1;

    @FXML
    private Button p1t2;

    @FXML
    private Button p1t3;

    @FXML
    private Button p2t1;

    @FXML
    private Button p2t2;

    @FXML
    private CheckBox piilotaVkl;

    @FXML
    private MenuItem sulje;

    @FXML
    private Button tile1_1;

    @FXML
    private Button tile1_2;

    @FXML
    private Button tile1_3;

    @FXML
    private Button tile1_4;

    @FXML
    private Button tile1_5;

    @FXML
    private Button tile2_1;

    @FXML
    private Button tile2_2;

    @FXML
    private Button tile2_3;

    @FXML
    private Button tile2_4;

    @FXML
    private Button tile2_5;

    @FXML
    private Button tile3_1;

    @FXML
    private Button tile3_2;

    @FXML
    private Button tile3_3;

    @FXML
    private Button tile3_4;

    @FXML
    private Button tile3_5;

    @FXML
    private Button tile4_1;

    @FXML
    private Button tile4_2;

    @FXML
    private Button tile4_3;

    @FXML
    private Button tile4_4;

    @FXML
    private Button tile4_5;

    @FXML
    private Button tile5_1;

    @FXML
    private Button tile5_2;

    @FXML
    private Button tile5_3;

    @FXML
    private Button tile5_4;

    @FXML
    private Button tile5_5;

    @FXML
    private Button tile6_1;

    @FXML
    private Button tile6_2;

    @FXML
    private Button tile6_3;

    @FXML
    private Button tile6_4;

    @FXML
    private Button tile6_5;

    @FXML
    private Button tile7_1;

    @FXML
    private Button tile7_2;

    @FXML
    private Button tile7_3;

    @FXML
    private Button tile7_4;

    @FXML
    private Button tile7_5;

    @FXML
    private Button uusiPro;

    @FXML
    private Button uusiTeht;

    @FXML
    private TabPane lehti;


    //-------------------------------------------------------------------------------------------
    private Harakka harakka = new Harakka();



    @FXML
    void HandleMuokkaa(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Tästä saat muokattua");
    }

    @FXML
    void HandlePiilota(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Tästä saat piilotettua viikonlopun");
    }


    /** Tapahtumankäsittelijä kun painetaan lisää Projekti painiketta päämenussa.
     * avaa modaalisen ikkunan ja pyytää uuden projektin tiedot.
     *
     * @param event klikataan päämenussa lisää projekti
     */
    @FXML
    void handleLisaaPro(ActionEvent event) {

        Tab uusiLehti = new Tab();
        uusiLehti.setContent(new Label()); //luodaan projektinäkymään uusi lehti oottamaan jos se mahdollisesti
        lehti.getTabs().add(uusiLehti);


        Projekti uusiProjekti = new Projekti();
        uusiProjekti = lisaaProjekti(); //luotava projekti joka palautetaan kun tullaan pois lisääprojekti ikkunasta

        if (uusiProjekti == null || uusiProjekti.getNimi().isEmpty() || uusiProjekti.getNimi().isBlank()){ //jos tullaan pois nimettömällä projektilla
            //sitten pitää poistaa luotu tabi
            lehti.getTabs().removeLast();
        }else {

            //muuten laitetaan uuden tabin nimeksi luodun projektin nimi
            uusiLehti.setText(uusiProjekti.getNimi());

            //lisätään uusiprojekti tietorakenteeseen
            try {
                harakka.lisaaProjekti(uusiProjekti);
            } catch (Exception e) {
                System.out.println("Lisääminene tietorakenteeseen ei onnistunut" + e);
            }
        }





    }

    @FXML
    void handleLisaaTeht(ActionEvent event) {
        ModalController.showModal(HarakkaController.class.getResource("LisääTehtävä.fxml"), "Muokkaa", null, "");
    }

    @FXML
    void handleMuokkaa(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Tästä saat muokattua tehtävää");
    }

    @FXML
    void handleTehtava(ActionEvent event) {
        ModalController.showModal(HarakkaController.class.getResource("Oksa.fxml"), "Muokkaa", null, "");
    }

    @FXML
    void handleTile(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Tästä saat muokattua tileä");
    }

    @FXML
    void suljeOhjelma(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Sulkee ohjelman");
    }

    @FXML
    void handlePoistaPro(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Poistaa projektin");
    }

    @FXML
    void handleApu(ActionEvent event) {
        Dialogs.showMessageDialog("Myöhemmin: Saat lisätietoja ohjelmasta");
    }

    @FXML
    public void lisaaLehti(String nimi){

    }


    /**Aliohjelma joka tuo esille projekin lisäämis ikkunan modalControllerin kautta
     *
     */
    private Projekti lisaaProjekti (){
        Projekti projekti = new Projekti(); //tähän palautetaan luotu projekti
        return LuoProjektiController.kysyProjekti(null, projekti);
    }


}
